//Part of the prototypical solution for the Microcontroller Programming Laboratory
//term project, winter semester 2010/11
// (c) Andreas Unterweger, Fachhochschule Salzburg, ITS

#ifndef _UTILS_H
#define _UTILS_H

//Writes the decimal ASCII representation of an unsigned long value into the given
//string and pads it with spaces (' ') until the maximum length
void SpacePaddedDecimalToASCII(unsigned long val, char xdata *str, unsigned char maxlen);

//Macros below replace functions in order to reduce code size
//Due to this, these macros' names are in camel case instead of upper case
//Please be aware that some macros are missing or have been modified deliberately

//Initialization value for an 8 bit unsigned variable representing a running light moving rightwards
#define RunningLightStart 0x80
//Sets the given 8 bit unsigned variable to the next step of a running light moving rightwards
#define NextRunningLight(var) (((var) >>= 1) ? (var) : ((var) = RunningLightStart))

//Converts a byte value into a percent value
#define ByteToPercent(value) (((unsigned short)(value) * 100) / 255)
//Converts a byte value into an 8 bit progress value (p.e. 0000 0111 between 32 and 47)
#define ByteToProgress(value) (~(unsigned char)(0xFF >> (((unsigned short)((value) + 1)) / 32)))

//Disables X2 mode (modified from original source version)
#define DisableX2Mode() CKCON &= ~1

#endif